﻿Option Strict On
Option Explicit On
Option Infer Off

Public Class frmMain
    'Declare two Arrays, one for student names one for student grades.  Both without an upper bound
    (INSERT CODE HERE)
    (INSERT CODE HERE)

    'When the form loads...
    Private Sub frmMain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'Initialize our student arrays by reading in the files and put the student info in the lst
        InitializeStudents()
        'Find the best students now that I've added one
        FindAboveAverage()
    End Sub

    'When I click the add student button...
    Private Sub btnAddStudent_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAddStudent.Click
        'Prompt the user for a new student, add that information to our arrays and put the new
        'student in the list
        AddNewStudent()
        'Find the best students now that I've added one
        FindAboveAverage()
    End Sub

    'Name:         InitializeStudents
    'Parameters:   None
    'Returns:      None
    'Description:  Reads the students' information from files, puts them into our arrays
    '              then it populates the list with all the students' information
    Sub InitializeStudents()
        'Read the student grades from file as string to temp array, then l
        Dim tempArray() As String = IO.File.ReadAllLines("studentGrades.txt")
        ReDim studentGrades(tempArray.Count - 1)

        'Read in the student names to the student names array
        studentNames = IO.File.ReadAllLines("studentNames.txt")

        'clear everything from the all list
        lstAll.Items.Clear()

        'Loop over aacg grade, convert it to a double and put it in studentGrades.  
        'Also, put the students and their grades into the all list
        For i As Integer = 0 To tempArray.Count - 1
            studentGrades(i) = CDbl(tempArray(i))
            lstAll.Items.Add(studentNames(i) & " " & studentGrades(i))
        Next
    End Sub

    'Name:         FindAboveAverage
    'Parameters:   None
    'Returns:      None
    'Description:  Finds the average grade of all the students, and displays which students
    '              are above the average in the above average list box
    Sub FindAboveAverage()
        'The number of students...
        Dim numberStudents As Integer = (INSERT CODE HERE)
        Dim sum As Double = 0
        Dim average As Double

        'Clear all items from the above average list
        (INSERT CODE HERE)

        'Find the sum
        (INSERT CODE HERE)

        'Finds the average
        (INSERT CODE HERE)

        'Find which students are above the average and add them to the best students list
        (INSERT CODE HERE)
    End Sub

    'Name:         AddNewStudent
    'Parameters:   None
    'Returns:      None
    'Description:  Takes in a new student's name and grade, adds that information to our arrays
    '              then adds the information to our list box with all the students
    Sub AddNewStudent()
        'Prompt the user for a student name, then a student grade
        Dim newStudentName As String = (INSERT CODE HERE)
        Dim newStudentGrade As Double = (INSERT CODE HERE)

        'Increase the size of our arrays by one
        (INSERT CODE HERE)
        (INSERT CODE HERE)

        'Put the new name and grade in the empty spot in our arrays
        (INSERT CODE HERE)
        (INSERT CODE HERE)

        'Add the new student to the all list
        (INSERT CODE HERE)
    End Sub
End Class
